/*
 * Copyright (c) 2006-2021, RT-Thread Development Team
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Change Logs:
 * Date           Author       Notes
 * 2021-09-02     Meco Man     First version
 */

#ifndef __FCNTL_H__
#define __FCNTL_H__

#include_next <fcntl.h>

#define O_CREAT        0100
#define O_EXCL         0200
#define O_NOCTTY       0400
#define O_TRUNC       01000
#define O_APPEND      02000
#define O_NONBLOCK    04000
#define O_DSYNC      010000
#define O_SYNC     04010000
#define O_RSYNC    04010000
#define O_DIRECTORY  040000
#define O_NOFOLLOW  0100000
#define O_CLOEXEC  02000000

#define O_ASYNC      020000
#define O_DIRECT    0200000
#define O_LARGEFILE 0400000
#define O_NOATIME  01000000
#define O_PATH    010000000
#define O_TMPFILE 020040000
#define O_NDELAY O_NONBLOCK

#ifndef O_BINARY
#define O_BINARY 00
#endif

#ifndef O_SEARCH
#define O_SEARCH  O_PATH
#endif /* O_SEARCH */

#ifndef O_EXEC
#define O_EXEC    O_PATH
#endif /* O_EXEC */

#endif
